#!/usr/bin/perl

#Copyright 2002  PhaethonH
#Distributed under the Perl Artistic License

undef @level;
undef %vchat;

$color_label = "^3";
$color_leaf = "^7";
$color_node = "^6";

sub transcribe_menu
{
  local $l = $_[0];
  local (@s, $munge, $level, $node, $label, $cmd);
  @s = split(/\t/, $l);

#print "Passed line is:$l\n";

  if (substr($l, 0, 1) eq "#") { return 0; }
  if (substr($l, 0, 2) eq "//") { return 0; }
  if (substr($l, 0, 1) eq ";") { return 0; }

  undef $cmd;
  $munge = 0;
  while ($s[0] eq "")
    {
      $munge++;
      shift @s;
    }

  $level[$munge] = $s[0];

  $level = join("", @level);
  $menu = substr($level, 0, $munge);
  $node = substr($level, 0, $munge+1);
  $label = $s[1];

#  print "Node name is $node\n";
  if (defined($s[2]))
    {
      $cmd = $s[2];
#      print "Leaf node is $node => $cmd\n";
    }
#  print "To add to menu [$menu]\n";
#  push(@{$vchat{$menu}}, [$node, $label, $cmd]);
  $vchat{$menu}->{$node} = [$label, $cmd];
}

sub dump_menu {
  local ($menu, $label, $cmd);
  for $x (sort keys %vchat)
    {
      print "Have menu '$x'\n";
#      for $i (0..$#{@{$vchat{$x}}})
      $i = 0;
      for $menu (sort keys %{$vchat{$x}})
        {
          ($label, $cmd) = @{$vchat{$x}->{$menu}};
          print " => ";
          print $menu;
          print " - ";
          print $label;
          if ($cmd)
            {
              print " : $cmd";
            }
          else
            {
              print " ... ";
            }
          print "\n";
        }
    }
}

sub write_cfgs
{
  local ($key, $menu, $label, $cmd);

  #Entrance.
  print "Create file 'vchat.cfg'\n";
  open(CFG, ">vchat.cfg") || die "Can't write vchat.cfg: $!";
  print CFG "seta cl_vchat .\n";
  print CFG 'seta vchat "writeconfig vchat/S.cfg; exec vchat/_.cfg' . "\n";
  close(CFG);

  if (!-d "./vchat")
    {
      mkdir("vchat") || die "Can't create directory vchat/: $!";
    }

  #Exit vchats.
  print "Create file 'vchat/0.cfg'\n";
  open(CFG, ">vchat/0.cfg") || die "Can't write vchat/0.cfg: $!";
  print CFG "set cl_vchat .\n";
  print CFG "exec vchat/1.cfg\n";
  print CFG "exec vchat/S.cfg\n";
  close CFG;

  #Shared commands.
  print "Create file 'vchat/1.cfg'\n";
  open(CFG, ">vchat/1.cfg") || die "Can't write vchat/1.cfg: $!";
#  print CFG "unbindall\n";
  for $i (qw(SPACE TAB ENTER BACKSPACE), '0'..'9', 'a'..'z')
    {
      print CFG "bind $i exec vchat/0.cfg\n";
    }
  for($i=0;$i<24;$i++)
    {
      print CFG "set cl_vchat_$i \"\"\n";
    }
  close(CFG);

  for $x (sort keys %vchat)
    {
      print "Create file 'vchat/_${x}.cfg'\n";
      open(CFG, ">vchat/_${x}.cfg") || die "Can't write vchat/_${x}.cfg: $!";
      $m = $x;
      $m = "_" if $m eq "";

      $k = $x;
      $l = $vchat{substr($k, 0, (length $k) - 1)}->{$k}->[0];
      $l = '"ROOT"' if $x eq "";

      $k = '_' if $x eq "";
      print CFG "exec vchat/1.cfg\n";
      print CFG "set cl_vchat \"$m\"\n";
      print CFG "set cl_vchat_0 $l\n";

      $entrynum = 0;
      for $menu (sort keys %{$vchat{$x}})
        {
          $entrynum++;
          ($label, $cmd) = @{$vchat{$x}->{$menu}};
          $menu =~ /(.)$/;
          $keyseq = $1;

          $key = substr($menu, (length $menu) - 1, 1);
          if (!$key)
            {
              $entrynum--;
              next;
            }
          $label =~ tr/"//d;

          $bindkey = lc($key);
          if ($cmd)
            {
              $cmd =~ s|"$|; exec vchat/0.cfg"|;
              $bindline = "bind $bindkey $cmd\n";
              $label = "${color_leaf}$label${color_leaf}";
            }
          else
            {
              $bindline = "bind $bindkey exec vchat/_${menu}.cfg\n";
              $label = "${color_node}$label${color_normal}";
            }
          $key = "${color_label}${key}${color_normal}";
          print CFG "set cl_vchat_$entrynum \"${key}: $label\"\n";
          print CFG $bindline;
        }
      close(CFG);
    }
}


open(VCHAT,"<vchat.txt") || die "Can't open";
while (defined($mline=<VCHAT>)) {
  $mline =~ tr/\n\r//d;
  transcribe_menu($mline);
}

#dump_menu();
write_cfgs();
